function [mw] = WaterMass(sdof,lengthvector,wdepth,nnel,ndof,Dn,tn,NodeMassTrap1,NodeMassTrap2,MassTrap,Dmt,leng)

% %%%  Function Description:
% Function to add the effect of water in the tower as a added mass.
%

wdens=1025; %kg/m3 water density

%loop to add the water inside the tower from the foundation to the MSL
mw=zeros(sdof,sdof);
[difference,NodeWater]=min(abs(lengthvector-wdepth));
for i=1:NodeWater-1 %elements under the MSL
index=elementdof(i,nnel,ndof);
Dmid=(Dn(i)+Dn(i+1))/2; %considering elements with constant D and t in each element
tmid=(tn(i)+tn(i+1))/2;
% mass matrix for the water
A=pi/4*(Dmid-2*tmid)^2;         %Area in the middle of the element

if i>=NodeMassTrap1 && i<=NodeMassTrap2-1 && MassTrap=='Y'
    A=A+pi/4*(Dmt-Dmid)^2;
end
mass=wdens*A;
    mm1=mass*leng/420;
    m=mm1*[156      22*leng   54       -13*leng;...
          22*leng  4*leng^2  13*leng  -3*leng^2;...
          54       13*leng   156      -22*leng;...
         -13*leng -3*leng^2 -22*leng   4*leng^2];
mw=assemble(mw,m,index); % assemble element mass matrices into system matrix for the water     
end

end

